--------------------------------------------------------------------------------
-- ColorsLib 1.0.1 -- by Ivan Llanas -------------------------------------------
--------------------------------------------------------------------------------
local CL_VERSION = 1;

--------------------------------------------------------------------------------
-- Funcions de suport ----------------------------------------------------------
--------------------------------------------------------------------------------
function RGBToTextColor (rgb, alpha)

   return string.format ("|c%0.2x%0.2x%0.2x%0.2x", floor((alpha or 1)*255), floor(rgb.r*255), floor(rgb.g*255), floor(rgb.b*255));
end;


--------------------------------------------------------------------------------
-- Comprovacio de versio -------------------------------------------------------
--------------------------------------------------------------------------------
local createCL = false;

   if CL then
      if     not CL.Version then         createCL = true;
      elseif CL.Version<CL_VERSION then  createCL = true;
      end;
   else                                  createCL = true;
   end;

--------------------------------------------------------------------------------
-- Creacio de l'objecte principal ----------------------------------------------
--------------------------------------------------------------------------------
if createCL then

   CL = {}; CL.Version = 1;
   
   -- Colors globals
   CL.clWhite_RGB     = {r=1    , g=1    , b=1     };     CL.clWhite      = RGBToTextColor (CL.clWhite_RGB);
   CL.clSilver_RGB    = {r=0.75 , g=0.75 , b=0.75  };     CL.clSilver     = RGBToTextColor (CL.clSilver_RGB);
   CL.clGray_RGB      = {r=0.625, g=0.625, b=0.625 };     CL.clGray       = RGBToTextColor (CL.clGray_RGB);
   CL.clDarkGray_RGB  = {r=0.25 , g=0.25 , b=0.25  };     CL.clDarkGray   = RGBToTextColor (CL.clDarkGray_RGB);
   CL.clBlack_RGB     = {r=0    , g=0    , b=0     };     CL.clBlack      = RGBToTextColor (CL.clBlack_RGB);

   CL.clRed_RGB       = {r=1    , g=0.125, b=0.125 };     CL.clRed        = RGBToTextColor (CL.clRed_RGB);
   CL.clRedL_RGB      = {r=1    , g=0.5  , b=0.5   };     CL.clRedL       = RGBToTextColor (CL.clRedL_RGB);
   CL.clRedM_RGB      = {r=1    , g=0.25 , b=0.25  };     CL.clRedM       = RGBToTextColor (CL.clRedM_RGB);
   CL.clBrown_RGB     = {r=0.5  , g=0.25 , b=0     };     CL.clBrown      = RGBToTextColor (CL.clBrown_RGB);

   CL.clGreen_RGB     = {r=0    , g=1    , b=0     };     CL.clGreen      = RGBToTextColor (CL.clGreen_RGB);
   CL.clGreenL_RGB    = {r=0.5  , g=1    , b=0.5   };     CL.clGreenL     = RGBToTextColor (CL.clGreenL_RGB);
   CL.clLime_RGB      = {r=0.125, g=1    , b=0.125 };     CL.clLime       = RGBToTextColor (CL.clLime_RGB);

   CL.clBlue_RGB      = {r=0    , g=0    , b=1     };     CL.clBlue       = RGBToTextColor (CL.clBlue_RGB);
   CL.clBlueL_RGB     = {r=0.5  , g=0.5  , b=1     };     CL.clBlueL      = RGBToTextColor (CL.clBlueL_RGB);
   CL.clAqua_RGB      = {r=0    , g=1    , b=1     };     CL.clAqua       = RGBToTextColor (CL.clAqua_RGB);

   CL.clYellow_RGB    = {r=1    , g=1    , b=0     };     CL.clYellow     = RGBToTextColor (CL.clYellow_RGB);
   CL.clYellowL_RGB   = {r=1    , g=1    , b=0     };     CL.clYellowL    = RGBToTextColor (CL.clYellowL_RGB);

   CL.clBlizzard_RGB  = {r=1    , g=0.8125,b=0     };     CL.clBlizzard   = RGBToTextColor (CL.clBlizzard_RGB);

   -- Colors de les classes

   CL.clHunter_RGB      = {r=0.6  , g=0.85 , b=0.45  };   CL.clHunter      = RGBToTextColor (CL.clHunter_RGB);
   CL.clShaman_RGB      = {r=0.15 , g=0.35 , b=1     };   CL.clShaman      = RGBToTextColor (CL.clShaman_RGB);
   CL.clPaladin_RGB     = {r=0.9  , g=0.5  , b=0.68  };   CL.clPaladin     = RGBToTextColor (CL.clPaladin_RGB);
   CL.clWarrior_RGB     = {r=0.78 , g=0.6  , b=0.42  };   CL.clWarrior     = RGBToTextColor (CL.clWarrior_RGB);
   CL.clDeathKnight_RGB = {r=0.75 , g=0.12 , b=0.25  };   CL.clDeathKnight = RGBToTextColor (CL.clDeathKnight_RGB);
   CL.clRogue_RGB       = {r=1    , g=1    , b=0.4   };   CL.clRogue       = RGBToTextColor (CL.clRogue_RGB);
   CL.clDruid_RGB       = {r=1    , g=0.5  , b=0     };   CL.clDruid       = RGBToTextColor (CL.clDruid_RGB);
   CL.clWarlock_RGB     = {r=0.57 , g=0.5  , b=0.78  };   CL.clWarlock     = RGBToTextColor (CL.clWarlock_RGB);
   CL.clMage_RGB        = CL.clAqua_RGB;                  CL.clMage        = RGBToTextColor (CL.clMage_RGB);
   CL.clPriest_RGB      = CL.clWhite_RGB;                 CL.clPriest      = RGBToTextColor (CL.clPriest_RGB);

   CL.clClasses         = {};
   CL.clClasses_RGB     = {};

   CL.clClasses["WARRIOR"]     = CL.clWarrior;            CL.clClasses_RGB["WARRIOR"]     = CL.clWarrior_RGB;
   CL.clClasses["PALADIN"]     = CL.clPaladin;            CL.clClasses_RGB["PALADIN"]     = CL.clPaladin_RGB;
   CL.clClasses["DEATHKNIGHT"] = CL.clDeathKnight;        CL.clClasses_RGB["DEATHKNIGHT"] = CL.clDeathKnight_RGB;
   CL.clClasses["HUNTER"]      = CL.clHunter;             CL.clClasses_RGB["HUNTER"]      = CL.clHunter_RGB;
   CL.clClasses["SHAMAN"]      = CL.clShaman;             CL.clClasses_RGB["SHAMAN"]      = CL.clShaman_RGB;
   CL.clClasses["ROGUE"]       = CL.clRogue;              CL.clClasses_RGB["ROGUE"]       = CL.clRogue_RGB;
   CL.clClasses["DRUID"]       = CL.clDruid;              CL.clClasses_RGB["DRUID"]       = CL.clDruid_RGB;
   CL.clClasses["WARLOCK"]     = CL.clWarlock;            CL.clClasses_RGB["WARLOCK"]     = CL.clWarlock_RGB;
   CL.clClasses["MAGE"]        = CL.clMage;               CL.clClasses_RGB["MAGE"]        = CL.clMage_RGB;
   CL.clClasses["PRIEST"]      = CL.clPriest;             CL.clClasses_RGB["PRIEST"]      = CL.clPriest_RGB;

   -- Colors dels tipus d'energies (UnitPowerType)

   CL.clMana_RGB       = CL.clBlue_RGB;                   CL.clMana       = RGBToTextColor (CL.clMana_RGB);
   CL.clRage_RGB       = CL.clRed_RGB;                    CL.clRage       = RGBToTextColor (CL.clRage_RGB);
   CL.clEnergy_RGB     = CL.clYellow_RGB;                 CL.clEnergy     = RGBToTextColor (CL.clEnergy_RGB);
   CL.clRunicPower_RGB = {r=0   , g=0.75 , b=1     };     CL.clRunicPower = RGBToTextColor (CL.clRunicPower_RGB);

   CL.clPowerTypes      = {};
   CL.clPowerTypes_RGB  = {};
   
   CL.clPowerTypes[0] = CL.clMana;                        CL.clPowerTypes_RGB[0] = CL.clMana_RGB;
   CL.clPowerTypes[1] = CL.clRage;                        CL.clPowerTypes_RGB[1] = CL.clRage_RGB;
   CL.clPowerTypes[3] = CL.clEnergy;                      CL.clPowerTypes_RGB[3] = CL.clEnergy_RGB;
   CL.clPowerTypes[6] = CL.clRunicPower;                  CL.clPowerTypes_RGB[6] = CL.clRunicPower_RGB;

   -- Experiencia

   CL.clXPNormal_RGB  = {r=0.5  , g=0    , b=0.5   };     CL.clXPNormal   = RGBToTextColor (CL.clXPNormal_RGB);
   CL.clXPRested_RGB  = {r=0   , g=0.5   , b=1     };     CL.clXPRested   = RGBToTextColor (CL.clXPRested_RGB);

   -- Reputacio

   CL.clExalted_RGB   = {r=0    , g=0.5  , b=1     };     CL.clExalted    = RGBToTextColor (CL.clExalted_RGB);
   CL.clRevered_RGB   = {r=0.25 , g=0.625, b=0.75  };     CL.clRevered    = RGBToTextColor (CL.clRevered_RGB);
   CL.clHonored_RGB   = {r=0.5  , g=0.75 , b=0.5   };     CL.clHonored    = RGBToTextColor (CL.clHonored_RGB);
   CL.clFriendly_RGB  = {r=0.75 , g=0.8125,b=0.25  };     CL.clFriendly   = RGBToTextColor (CL.clFriendly_RGB);
   CL.clNeutral_RGB   = {r=1    , g=1    , b=0     };     CL.clNeutral    = RGBToTextColor (CL.clNeutral_RGB);
   CL.clUnfriendly_RGB= {r=1    , g=0.5625,b=0.125 };     CL.clUnfriendly = RGBToTextColor (CL.clUnfriendly_RGB);
   CL.clHostile_RGB   = {r=1    , g=0    , b=0     };     CL.clHostile    = RGBToTextColor (CL.clHostile_RGB);
   CL.clHated_RGB     = {r=0.75 , g=0    , b=0     };     CL.clHated      = RGBToTextColor (CL.clHated_RGB);

   CL.clReputation     = {};
   CL.clReputation_RGB = {};

   CL.clReputation[8] = CL.clExalted;                     CL.clReputation_RGB[8] = CL.clExalted_RGB;
   CL.clReputation[7] = CL.clRevered;                     CL.clReputation_RGB[7] = CL.clRevered_RGB;
   CL.clReputation[6] = CL.clHonored;                     CL.clReputation_RGB[6] = CL.clHonored_RGB;
   CL.clReputation[5] = CL.clFriendly;                    CL.clReputation_RGB[5] = CL.clFriendly_RGB;
   CL.clReputation[4] = CL.clNeutral;                     CL.clReputation_RGB[4] = CL.clNeutral_RGB;
   CL.clReputation[3] = CL.clUnfriendly;                  CL.clReputation_RGB[3] = CL.clUnfriendly_RGB;
   CL.clReputation[2] = CL.clHostile;                     CL.clReputation_RGB[2] = CL.clHostile_RGB;
   CL.clReputation[1] = CL.clHated;                       CL.clReputation_RGB[1] = CL.clHated_RGB;
end;


